/******************************************************************************\
 *           ___        __                                                    *
 *          /\_ \    __/\ \                                                   *
 *          \//\ \  /\_\ \ \____    ___   _____   _____      __               *
 *            \ \ \ \/\ \ \ '__`\  /'___\/\ '__`\/\ '__`\  /'__`\             *
 *             \_\ \_\ \ \ \ \L\ \/\ \__/\ \ \L\ \ \ \L\ \/\ \L\.\_           *
 *             /\____\\ \_\ \_,__/\ \____\\ \ ,__/\ \ ,__/\ \__/.\_\          *
 *             \/____/ \/_/\/___/  \/____/ \ \ \/  \ \ \/  \/__/\/_/          *
 *                                          \ \_\   \ \_\                     *
 *                                           \/_/    \/_/                     *
 *                                                                            *
 * Copyright (C) 2011, 2012                                                   *
 * Dominik Charousset <dominik.charousset@haw-hamburg.de>                     *
 *                                                                            *
 * This file is part of libcppa.                                              *
 * libcppa is free software: you can redistribute it and/or modify it under   *
 * the terms of the GNU Lesser General Public License as published by the     *
 * Free Software Foundation, either version 3 of the License                  *
 * or (at your option) any later version.                                     *
 *                                                                            *
 * libcppa is distributed in the hope that it will be useful,                 *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                       *
 * See the GNU Lesser General Public License for more details.                *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public License   *
 * along with libcppa. If not, see <http://www.gnu.org/licenses/>.            *
\******************************************************************************/


#ifndef POST_OFFICE_HPP
#define POST_OFFICE_HPP

#include <memory>

#include "cppa/actor_proxy.hpp"
#include "cppa/detail/native_socket.hpp"

namespace cppa { namespace detail {

void post_office_loop(int pipe_read_handle, int pipe_write_handle);

void post_office_add_peer(native_socket_type peer_socket,
                          process_information_ptr const& peer_ptr,
                          actor_proxy_ptr const& peer_actor_ptr,
                          std::unique_ptr<attachable>&& peer_observer);

void post_office_publish(native_socket_type server_socket,
                         actor_ptr const& published_actor);

void post_office_unpublish(actor_id whom);

void post_office_close_socket(native_socket_type sfd);

} } // namespace cppa::detail

#endif // POST_OFFICE_HPP
